/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dnc.controllers;

import dnc.networking.Client;
import dnc.networking.Listener;
import dnc.views.CForm;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.awt.event.WindowEvent;
import java.io.IOException;
import java.util.Observable;
import java.util.Observer;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author jp72924
 */
public class CFormController implements ApplicationController, Observer {
    
    private CForm form;
    private Client client;
    private Listener listener;
    private Thread th;
    private String nickname;
    private boolean isEmpty;

    public CFormController(Client client, String nickname) {
        this.init();
        this.client = client;
        this.listener = new Listener(client);
        this.listener.addObserver(this);
        this.th = new Thread(listener);
        this.nickname = nickname;
        this.isEmpty = true;
    }

    @Override
    public final void init() {
        if (form == null) {
            form = new CForm();
            form.setLocationRelativeTo(null);
            
            form.addWindowListener(new java.awt.event.WindowListener() {
                @Override
                public void windowOpened(WindowEvent e) {}

                @Override
                public void windowClosing(WindowEvent e) {
                    try {
                        listener.shutdown();
                        client.close();
                    } catch (IOException ex) {
                        Logger.getLogger(CFormController.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }

                @Override
                public void windowClosed(WindowEvent e) {}

                @Override
                public void windowIconified(WindowEvent e) {}

                @Override
                public void windowDeiconified(WindowEvent e) {}

                @Override
                public void windowActivated(WindowEvent e) {}

                @Override
                public void windowDeactivated(WindowEvent e) {}
            });
            
            form.getTextInput().addKeyListener(new java.awt.event.KeyListener() {
                @Override
                public void keyTyped(KeyEvent e) {}

                @Override
                public void keyPressed(KeyEvent e) {
                    if (e.getKeyCode() == 10) {
                        sendMessage(null);
                    }
                }

                @Override
                public void keyReleased(KeyEvent e) {
                    if (form.getTextInput().getText().length() == 0) {
                        isEmpty = true;
                    } else {
                        isEmpty = false;
                    }
                }
            });
            
            form.getSendButton().addActionListener(new java.awt.event.ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    sendMessage(e);
                }
            });
        }
    }

    @Override
    public void run() {
        th.start();
        form.setVisible(true);
    }
    
    @Override
    public void update(Observable o, Object arg) {
        form.getTextOutput().append(arg + "\n");
    }
    
    private void clearInput() {
        form.getTextInput().setText("");
    }
    
    private void sendMessage(java.awt.event.ActionEvent e) {
        String text = form.getTextInput().getText();
        String message = nickname + ": " + text;
        
        if (!isEmpty) {
            form.getTextOutput().append(message + "\n");
            client.send(message);
            clearInput();
        }
    }
    
}
